/*
 * This software licensed under BIXOLON CO LTD
 * WS_parser JavaScript API version 1.0.0 
 * Written By Sahaya Darcius P  Aug-02-2016 Bixolon Co Ltd, Pangyo City, South Korea
 * Mail: sahaya@bixolon.kr
*/
function BGTParser() {
	this.PrintData = new Array();
	this.indexPos = 0;
}

BGTParser.prototype = {
	/*
	 Parse Allignment 
	*/
	ParseAlign : function(pos){
		var allignment = [0x1B,0x61,0x01];
		var i=0;
		if(pos =="left") allignment[2] = 0x00;
		if(pos =="center") allignment[2] = 0x01;
		if(pos =="right") allignment[2] = 0x02;
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = allignment[i];
			this.indexPos++;
		}
				
	},
	/*
	 Parse PaperFeed 
	*/
	ParseFeed : function(type,value){
		var feed_unit = [0x1B,0x4A,0x1E];
		var feedVal=[];
		var i=0;
		if(type =="line") {
			for(i=0;i<value;i++) 
			{
				this.PrintData[this.indexPos] = 0x0A;
				this.indexPos++;
			}
			
		}
		else if(type =="unit"){
			feed_unit[2] = value;
			for(i=0;i<3;i++)
			{
				this.PrintData[this.indexPos] = feed_unit[i];
				this.indexPos++;
			}
			
		}
				
	},
	
	/*
	 Parse NVlogo 
	*/
	ParseNVlogo : function(keycode,size){
		var printer_NV = [0x1D,0x28,0x4c,0x06,0x00,0x30,0x45,0x30,0x30,0x01,0x01];
		var i=0;		
		var kcode = parseInt(keycode,10) + 48;
		printer_NV[8] = kcode;	
		if(size =="normal") {
			printer_NV[9] = 0x01;printer_NV[10] = 0x01;
		}
		else if(size =="dwd"){
			printer_NV[9] = 0x02;printer_NV[10] = 0x01;
		}
		else if(size =="dht"){
			printer_NV[9] = 0x01;printer_NV[10] = 0x02;
		}
		else if(size =="quadruple"){
			printer_NV[9] = 0x02;printer_NV[10] = 0x02;
		}
		for(i=0;i<11;i++)
		{
			this.PrintData[this.indexPos] = printer_NV[i];
			this.indexPos++;		
		}
		
		
	},
	/*
	 Parse Barcode 
	*/
	ParseText : function(font,ics,tcode,wd,ht,lsp,bold,uline,rev,updown,rot,data){
		var reverse_print 	= [0x1D,0x42,0x00];
		var text_pos 		= [0x1B,0x24,0x00,0x00];
		var text_size 		= [0x1D,0x21,0x00];
		var text_style		= [0x1B,0x21,0x00];
		var text_rotate		= [0x1B,0x56,0x00];
		var text_ics		= [0x1B,0x52,0x00];
		var text_code_page	= [0x1B,0x74,0x00];
		var text_line_space	= [0x1B,0x33,0x01];
		var text_line_space_default	= [0x1B,0x32];
		var upside_down		= [0x1B,0x7B,0x00];
		var textStyle = 0x00;
		var textSize = 0x00;
		if(font =="fontb") {
			textStyle = 0x01;
		}
		else if(font =="fontc"){
			textStyle = 0x02;
		}		
		if(bold =="true"){
			textStyle = textStyle |0x08;
		}
		if(uline =="true"){
			textStyle = textStyle |0x80;
		}
		text_style[2] = textStyle; 
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = text_style[i];
			this.indexPos++;
		}
		
		if(rev =="true"){
			reverse_print[2] = 0x01;
		}
		else{
			reverse_print[2] = 0x00;
		}
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = reverse_print[i];
			this.indexPos++;
		}
		
		if(updown =="true"){
			upside_down[2] = 0x01;
		}
		else{
			upside_down[2] = 0x00;
		}
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = upside_down[i];
			this.indexPos++;
		}
		
		if(rot =="90"){
			text_rotate[2]=0x01;
		}
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = text_rotate[i];
			this.indexPos++;
		}
		textSize = wd<<4;			
		textSize |= ht;
		text_size[2] = textSize;
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = text_size[i];
			this.indexPos++;
		}
		
		if(ics == "usa")
		{
			text_ics[2] = 0; 
			
		}
		else if(ics == "france")
		{
			text_ics[2] = 1; 
			
		}
		else if(ics == "germany") 
		{
			text_ics[2] = 2; 
			
		}
		else if(ics == "uk")
		{
			text_ics[2] = 3; 
			
		}
		else if(ics == "denmarkI")
		{
			text_ics[2] = 4; 
			
		}
		else if(ics == "sweden")
		{
			text_ics[2] = 5; 
			
		}
		else if(ics == "italy")
		{
			text_ics[2] = 6; 
			
		}
		else if(ics == "spainI")
		{
			
			text_ics[2]=7;
		}
		else if(ics == "japan")
		{
			
			text_ics[2]=8;
		}
		else if(ics == "norway")
		{
			 
			text_ics[2]=9;
		}
		else if(ics == "denmarkII")
		{
			
			text_ics[2]=10;
		}
		else if(ics == "spainII")
		{
			
			text_ics[2]=11;
		}
		else if(ics == "latinamerica") 
		{
			
			text_ics[2]=12;
		}
		else if(ics == "korea")
		{
			
			text_ics[2]=13;
		}
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = text_ics[i];
			this.indexPos++;
		}
		
		if(tcode == "page0") 
		{
			text_code_page[2]=0;
		}
		else if(tcode =="page1")
		{
			text_code_page[2]=1;
		}
		else if(tcode =="page2")
		{
			text_code_page[2]=2;
		}
		else if(tcode =="page3")
		{
			text_code_page[2]=3;
		}
		else if(tcode =="page4")
		{
			text_code_page[2]=4;
		}
		else if(tcode =="page5")
		{
			text_code_page[2]=5;
		}
		else if(tcode =="page16")
		{
			text_code_page[2]=16;
		}
		else if(tcode =="page17")
		{
			text_code_page[2]=17;
		}
		else if(tcode =="page18") 
		{
			text_code_page[2]=18;
		}
		else if(tcode =="page19")
		{
			text_code_page[2]=19;
		}
		else if(tcode =="page21")
		{
			text_code_page[2]=21;
		}
		else if(tcode =="page22")
		{
			text_code_page[2]=22;
		}
		else if(tcode =="page23")
		{
			text_code_page[2]=23;
		}
		else if(tcode =="page24")
		{
			text_code_page[2]=24;
		}
		else if(tcode =="page25")
		{
			text_code_page[2]=25;
		}
		else if(tcode =="page26")
		{
			text_code_page[2]=26;
		}
		else if(tcode =="page27")
		{
			text_code_page[2]=27;
		}
		else if(tcode =="page28")
		{
			text_code_page[2]=28;
		}
		else if(tcode =="page29")
		{
			text_code_page[2]=29;
		}
		else if(tcode =="page30")
		{
			text_code_page[2]=30;
		}
		else if(tcode =="page31")
		{
			text_code_page[2]=31;
		}
		else if(tcode =="page33")
		{
			text_code_page[2]=33;
		}
		else if(tcode =="page34")
		{
			text_code_page[2]=34;
		}
		else if(tcode =="page35")
		{
			text_code_page[2]=35;
		}
		else if(tcode =="page36")
		{
			text_code_page[2]=36;
		}
		else if(tcode =="page37")
		{
			text_code_page[2]=37;
		}
		else if(tcode =="page38")
		{
			text_code_page[2]=38;
		}
		else if(tcode =="page39")
		{
			text_code_page[2]=39;
		}
		else if(tcode =="page40")
		{
			text_code_page[2]=40;
		}
		else if(tcode =="page41")
		{
			text_code_page[2]=41;
		}
		else if(tcode =="page42")
		{
			text_code_page[2]=42;
		}
		else if(tcode =="page47")
		{
			text_code_page[2]=47;
		}
		else if(tcode =="page49")
		{
			text_code_page[2]=49;
		}
		else if(tcode =="page50")
		{
			text_code_page[2]=50;
		}
		else if(tcode =="page255")
		{
			text_code_page[2]=255;
		}
		
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = text_code_page[i];
			this.indexPos++;
		}
		if(lsp ==256){
			for(i=0;i<2;i++)
			{
				this.PrintData[this.indexPos] = text_line_space_default[i];
				this.indexPos++;
			}
			
		}
		else
		{
			for(i=0;i<3;i++)
			{
				this.PrintData[this.indexPos] = text_line_space[i];
				this.indexPos++;
			}
		}
		var codelen = data.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  data[i];
			this.indexPos++;
		}
		//alert("text=" +this.PrintData);		
	},
	/*
	 Parse Barcode 
	*/
	ParseBarcode : function(type,width,height,hri,data){
		var bar_code_text_pos = [0x1D,0x48,0x00];
		var print_bar_code = [0x1D,0x6B,0x00];
		var bar_code_height = [0x1D,0x68,0x64];
		var bar_code_width = [0x1D,0x77,0x03];
		var i=0, codelen =0;
		if(hri =="none") {
			bar_code_text_pos[2] = 0x00;
		}
		else if(hri =="above"){
			bar_code_text_pos[2] = 0x01;
		}
		else if(hri =="below"){
			bar_code_text_pos[2] =  0x02;
		}
		else if(hri =="both"){
			bar_code_text_pos[2] = 0x03;
		}
		bar_code_height[2] = height;
		bar_code_width[2] = width;
		
		if(type == "UPC-A")
		{
			print_bar_code[2] = 0;   
		}
		else if (type == "UPC-E")
		{
			print_bar_code[2] = 1;   
		}
		else if (type == "JAN13") 
		{
			print_bar_code[2] = 2;   
		}
		else if (type == "JAN8")
		{
			print_bar_code[2] = 3;   
		}
		else if (type == "Ean13")
		{
			print_bar_code[2] = 2;   
		}
		else if (type == "EAN8")
		{
			print_bar_code[2] = 3;   
		}
		else if (type == "CODE39")
		{
			print_bar_code[2] = 4;   
		}
		else if (type == "ITF")
		{
			print_bar_code[2] = 5;   
		}
		else if (type == "CODABAR")
		{
			print_bar_code[2] = 6;   
		}
		else if (type == "CODE93")
		{
			print_bar_code[2] = 72;   
		}
		else if (type == "CODE128")
		{
			print_bar_code[2] = 73;   
		}
		
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = bar_code_text_pos[i];
			this.indexPos++;
		}
		
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = bar_code_height[i];
			this.indexPos++;
		}
		
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = bar_code_width[i];
			this.indexPos++;
		}
		
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = print_bar_code[i];
			this.indexPos++;
		}
		if(typeof data === 'number') 
		{
			var BarCodeData = data.toString(); 
			codelen = BarCodeData.length;
			//alert("codelen" +codelen +"data="+BarCodeData);
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = BarCodeData.charCodeAt(i).toString(10);
				this.indexPos++;
			}
		}
		else
		{
			codelen = data.length;
			//alert("codelen" +codelen +"data="+data);
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = data.charCodeAt(i).toString(10);			
				this.indexPos++;
			}
		}		
		this.PrintData[this.indexPos] = 0x00;
		this.indexPos++;
		//alert("Barcode=" +this.PrintData);
			
	},
	
	/*
	 Parse QRcode 
	*/
	ParseQRcode : function(model,size,level,data){
		var qrcode_module	= [0x1D,0x28,0x6B,0x04,0x00,0x31,0x41,0x32,0];
		var qrcode_size		= [0x1D,0x28,0x6B,0x03,0x00,0x31,0x43,3];
		var qrcode_ErCrLevel= [0x1D,0x28,0x6B,0x03,0x00,0x31,0x45,48];
		var qrcode_store	= [0x1D,0x28,0x6B,0x00,0x00,0x31,0x50,0x30];
		var qrcode_print	= [0x1D,0x28,0x6B,0x03,0x00,0x31,0x51,0x30];
		var i=0, codelen =0;
		if(model =="mod1") {
			qrcode_module[7] = 0x31;
		}
		else if(model =="mod2"){
			qrcode_module[7] = 0x32;
		}
		for(i=0;i<9;i++)
		{
			this.PrintData[this.indexPos] = qrcode_module[i];
			this.indexPos++;
		}
		qrcode_size[7]=size;
		//qrcode_ErCrLevel[7]=level.toString();
		qrcode_ErCrLevel[7]=level;
		
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = qrcode_size[i];
			this.indexPos++;
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = qrcode_ErCrLevel[i];
			this.indexPos++;
		}
		
		
		if(typeof data === 'number') 
		{
			var QRData = data.toString(); 
			codelen = QRData.length;
			//alert("codelen" +codelen +"QRdata="+QRData);
			
			qrcode_store[3]=parseInt((3+codelen)%256);
			qrcode_store[4]=parseInt((3+codelen)/256);
			for(i=0;i<8;i++)
			{
				this.PrintData[this.indexPos] = qrcode_store[i];
				this.indexPos++;
			}
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = QRData.charCodeAt(i).toString(10);
				this.indexPos++;
			}
		}
		else
		{
			codelen = data.length;
			//alert("codelen" +codelen +"data="+data);
			qrcode_store[3]=parseInt((3+codelen)%256);
			qrcode_store[4]=parseInt((3+codelen)/256);
			for(i=0;i<8;i++)
			{
				this.PrintData[this.indexPos] = qrcode_store[i];
				this.indexPos++;
			}
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = data.charCodeAt(i).toString(10);
				this.indexPos++;
			}
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = qrcode_print[i];
			this.indexPos++;
		}		
	
		//alert("QRcode=" +this.PrintData);	
	},
	/*
	 Parse ParsePDF417 
	*/
	ParsePDF417 : function(model,col,row,wd,ht,level,data){
		var pdf417_col		= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x41,0x30];
		var pdf417_row		= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x42,0x03];
		var pdf417_width	= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x43,3];
		var pdf417_height	= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x44,3];
		var pdf417_ErCrLevel	= [0x1D,0x28,0x6B,0x04,0x00,0x30,0x45,0x30,0x30];
		var pdf417_mode		= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x46,0];
		var pdf417_store	= [0x1D,0x28,0x6B,0x00,0x00,0x30,0x50,0x30];
		var pdf417_print	= [0x1D,0x28,0x6B,0x03,0x00,0x30,0x51,0x30];
		var i=0, codelen =0;
		
		pdf417_col[7]=col;
		pdf417_row[7]=row;
		pdf417_width[7]=wd;
		pdf417_height[7]=ht;
		pdf417_mode[7]= model;
		//pdf417_ErCrLevel[8]=level.toString();
		pdf417_ErCrLevel[8]=level;
		
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = pdf417_col[i];
			this.indexPos++;
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = pdf417_row[i];
			this.indexPos++;
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = pdf417_width[i];
			this.indexPos++;
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = pdf417_height[i];
			this.indexPos++;
		}
		for(i=0;i<9;i++)
		{
			this.PrintData[this.indexPos] = pdf417_ErCrLevel[i];
			this.indexPos++;
		}
		
		if(typeof data === 'number') 
		{
			var PDFData = data.toString(); 
			codelen = PDFData.length;
			//alert("codelen" +codelen +"PDFData="+PDFData);
			
			pdf417_store[3]=parseInt((3+codelen)%256);
			pdf417_store[4]=parseInt((3+codelen)/256);
			for(i=0;i<8;i++)
			{
				this.PrintData[this.indexPos] = pdf417_store[i];
				this.indexPos++;
			}
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = PDFData.charCodeAt(i).toString(10);
				this.indexPos++;
			}
		}
		else
		{
			codelen = data.length;
			//alert("codelen" +codelen +"data="+data);
			pdf417_store[3]=parseInt((3+codelen)%256);
			pdf417_store[4]=parseInt((3+codelen)/256);
			for(i=0;i<8;i++)
			{
				this.PrintData[this.indexPos] = pdf417_store[i];
				this.indexPos++;
			}
			for(i=0;i<codelen;i++)
			{
				this.PrintData[this.indexPos] = data.charCodeAt(i).toString(10);
				this.indexPos++;
			}
		}
		for(i=0;i<8;i++)
		{
			this.PrintData[this.indexPos] = pdf417_print[i];
			this.indexPos++;
		}		
	
		//alert("PDF417Data=" +this.PrintData);	
	},
	/*
 	Parse PaperCut 
	*/
	ParseCut : function(cuttype){
		var printer_cut = [0x1D,0x56,66,1];
		var printer_cut_nofeed = [0x1D,0x56,48];
		var i=0;
		if(cuttype =="feed")
		{
			for(i=0;i<4;i++)
			{
				this.PrintData[this.indexPos] = printer_cut[i];
				this.indexPos++;
			}
		} 
		else if(cuttype =="nofeed") 
		{
			for(i=0;i<4;i++)
			{
				this.PrintData[this.indexPos] = printer_cut_nofeed[i];
				this.indexPos++;
			}
		
		}
		
		//alert("ParseCut=" +this.PrintData);
			
	},
	/*
 	Parse DKout 
	*/
	ParseDKout : function(connector,duration){
		var cash_draw =  [0x1B,0x70,0x00,0x19,0xFF];
		var i=0;
		if(connector == 'pin2')cash_draw[2] = 0x00;
		else if(connector == 'pin5')cash_draw[2] = 0x01;
		cash_draw[3] = duration/2;	
		
		for(i=0;i<5;i++)
		{
			this.PrintData[this.indexPos] = cash_draw[i];
			this.indexPos++;
		}
		
		//alert("ParseDKout=" +this.PrintData);
				
	},
	/*
 	Parse DKout 
	*/
	ParseCmd : function(decodeData){
		
		var j =0,i = 0,l,k,len = decodeData.length;
		var directIO = [];
		for(j =0,i = 0;i<len;)	
		{
			l = parseInt(decodeData[i],16);
			k = parseInt(decodeData[i+1],16);		
			directIO[j] = l<<4; directIO[j] |=k ;i+=2;j++;
		}
	
		for(i=0;i<directIO.length;i++)
		{
			this.PrintData[this.indexPos] = directIO[i];
			this.indexPos++;
		}
		
		//alert("ParseCmd=" +this.PrintData);
				
	},
	/*
 	Parse Reinit 
	*/
	ParseReinit : function(){
		var  print_init =[0x1b,0x40];
		var i=0;
		for(i=0;i<2;i++)
		{
			this.PrintData[this.indexPos] = print_init[i];
			this.indexPos++;
		}
		
		//alert("ParseReinit=" +this.PrintData);
				
	},
	/*
 	Parse Reinit 
	*/
	ParseBuzzer : function(){
		var  buzzer_cmd=[0x1E];
		var i=0;
		for(i=0;i<1;i++)
		{
			this.PrintData[this.indexPos] = buzzer_cmd[i];
			this.indexPos++;
		}
		
		//alert("ParseBuzzer=" +this.PrintData);
				
	},
	/*
 	Parse Reinit 
	*/
	ParseImg : function(ImageWidth,ImageHeight,BMPBuff){
		var print_raster 	= [0x1D,0x28,0x4C];
		var print_fn112		= [48,112,48,1,1,49];
		var end_raster		= [29,40,76,2,0,48,50];		
		var BytesPerLine = parseInt(((((ImageWidth) + 31) & ~31) >> 3));
		var Height =0,Excess_Height=0,pageSize=0,i=0,j=0,k=0,tbytes=0;
		if ( ImageHeight > 255)
		{
			Height = parseInt(ImageHeight / 255);
			Excess_Height = parseInt(ImageHeight % 255);
			pageSize = parseInt(((255) * (BytesPerLine)));
			k = 0;
			tbytes=0;		
			for ( j = 0; j < Height;j++)
			{
				for(i =0 ;i< 3;i++)
				{
					this.PrintData[this.indexPos++] = print_raster[i];
					
				}
				this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) % 256));
				this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) / 256));
				for(i=0;i<6;i++)
				{
					this.PrintData[this.indexPos++] = print_fn112[i];
				}
				this.PrintData[this.indexPos++] = parseInt((ImageWidth % 256));
				this.PrintData[this.indexPos++] = parseInt((ImageWidth / 256));
				this.PrintData[this.indexPos++] = parseInt((255 % 256));
				this.PrintData[this.indexPos++] = parseInt((255 / 256));
				//this.PrintData[this.indexPos++] = parseInt('\0');				
				var psz=pageSize-1;
				do
				{
					this.PrintData[this.indexPos++] = BMPBuff[tbytes++];
				}while(psz--)				
				
				
				for(i =0 ;i< 7;i++)
				{
					this.PrintData[this.indexPos++] = end_raster[i];
				}			
				//alert("ImageHeight:"+ImageHeight+" Height: "+Height+ " Excess_Height: "+ Excess_Height+ " tbytes= " +tbytes);
			}
			pageSize = parseInt(((Excess_Height) * (BytesPerLine)));
			for(i =0 ;i< 3;i++)
			{
				this.PrintData[this.indexPos++] = print_raster[i];
			}
			this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) % 256));
			this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) / 256));
			for(i=0;i<6;i++)
			{
				this.PrintData[this.indexPos++] = print_fn112[i];
			}
			this.PrintData[this.indexPos++] = parseInt((ImageWidth % 256));
			this.PrintData[this.indexPos++] = parseInt((ImageWidth / 256));
			this.PrintData[this.indexPos++] = parseInt((Excess_Height % 256));
			this.PrintData[this.indexPos++] = parseInt((Excess_Height / 256));
			//this.PrintData[this.indexPos++] = parseInt('\0');;
					
			var psz1=pageSize -1;
			do
			{
				this.PrintData[this.indexPos++] = BMPBuff[tbytes++];
			}while(psz1--)
			for(i =0 ;i< 7;i++)
			{
				this.PrintData[this.indexPos++] = end_raster[i];
			}
			//alert("ImageHeight:"+ImageHeight+" Height: "+Height+ " Excess_Height: "+ Excess_Height+ " tbytes= " +tbytes);
		}
		else
		{
		
			pageSize =  parseInt(((ImageHeight) * (BytesPerLine)));
			for(i =0 ;i< 3;i++)
			{
				this.PrintData[this.indexPos++] = print_raster[i];
			}
			this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) % 256));
			this.PrintData[this.indexPos++] = parseInt(((10 + pageSize) / 256));
			for(i=0;i<6;i++)
			{
				this.PrintData[this.indexPos++] = print_fn112[i];
			}
			
			this.PrintData[this.indexPos++] = parseInt((ImageWidth % 256));
			this.PrintData[this.indexPos++] = parseInt((ImageWidth / 256));
			this.PrintData[this.indexPos++] = parseInt((ImageHeight % 256));
			this.PrintData[this.indexPos++] = parseInt((ImageHeight / 256));
		
			/*for(i =0 ;i< pageSize;i++)
			{
				this.PrintData[this.indexPos++] = BMPBuff[tbytes++];
				
			}*/
			var psz2=pageSize-1;
			do
			{
				this.PrintData[this.indexPos++] = BMPBuff[tbytes++];
			}while(psz2--)
			
			for(i =0 ;i< 7;i++)
			{
				this.PrintData[this.indexPos++] = end_raster[i];
			}
			
				
		}
	
		
		//alert("ParseImg=" +this.PrintData);
				
	},
	ParsePageMode : function(pm){
		var setPageMode = [0x1b, 0x00];
		var i=0;
		if (pm == true)
			setPageMode[1] = 0x4c;
		else
			setPageMode[1] = 0x53;
		for(i=0;i<1;i++)
		{
			this.PrintData[this.indexPos] = setPageMode[i];
			this.indexPos++;
		}
	},

	ParsePrintArea : function(x,y,width,height){
		var setPrintArea = [0x1b, 0x57,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00];
		var i=0;
		setPrintArea[2] = parseInt((x % 256));
		setPrintArea[3] = parseInt((x / 256));
		setPrintArea[4] = parseInt((y % 256));
		setPrintArea[5] = parseInt((y / 256));
		setPrintArea[6] = parseInt((width % 256));
		setPrintArea[7] = parseInt((width / 256));
		setPrintArea[8] = parseInt((height % 256));
		setPrintArea[9] = parseInt((height / 256));
		for(i=0;i<10;i++)
		{
			this.PrintData[this.indexPos] = setPrintArea[i];
			this.indexPos++;
		}
	},

	ParsePrintDirection : function(rot){
		var setDirection = [0x1b, 0x54, 0x00],i;
		var r = parseInt(rot);
		if(r == 0)setDirection[2]=48;
		else if(r == 90)setDirection[2]=49;
		else if(r == 180)setDirection[2]=50;
		else if(r == 270)setDirection[2]=51;
		for(i=0;i<3;i++)
		{
			this.PrintData[this.indexPos] = setDirection[i];
			this.indexPos++;
		}
	},

	ParseVerticalPosition : function(pos,rel){
		var setVerticalPos = [0x1d,0x00,0x00,0x00],i;
		if(true == rel)setVerticalPos[1] = 0x5c;
		else setVerticalPos[1] = 0x24;
		setVerticalPos[2] = parseInt((pos % 256));
		setVerticalPos[3] = parseInt((pos / 256));
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = setVerticalPos[i];
			this.indexPos++;
		}
	},

	ParseHorizontalPosition : function(pos,rel){
		var setHorizontalPos = [0x1b,0x00,0x00,0x00],i;
		if(true == rel)setHorizontalPos[1] = 0x5c;
		else setHorizontalPos[1] = 0x24;
		setHorizontalPos[2] = parseInt((pos % 256));
		setHorizontalPos[3] = parseInt((pos / 256));
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = setHorizontalPos[i];
			this.indexPos++;
		}
	},

	ParseFormFeed : function(){
		var formFeed  = [0x0c, 0x00];
		var  formFeed=[0x0C];
		var i=0;
		for(i=0;i<1;i++)
		{
			this.PrintData[this.indexPos] = formFeed[i];
			this.indexPos++;
		}
	},

	ParseOneLabel : function(){
		var feedCmd = [0x7e, 0x50, 0x48, 0x0d, 0x0a],i;
		for(i=0;i<5;i++)
		{
			this.PrintData[this.indexPos] = feedCmd[i];
			this.indexPos++;
		}
	},
	ParseSpeed : function(speed1){
		var speedCmd = [0x53, 0x53, 0x00, 0x0d],i;
		this.PrintData[this.indexPos++] =0x53;
	    this.PrintData[this.indexPos++] =0x53;
		var i;
		var speed = speed1.toString();
	    var codelen = speed.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = speed.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++;

		/*
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = speedCmd[i];
			this.indexPos++;
		}*/
	},
	ParseDensity : function(dnst){
		//var densityCmd = [0x53,0x44, 0x00, 0x0d],i;

		this.PrintData[this.indexPos++] =0x53;
	    this.PrintData[this.indexPos++] =0x44;
		var i;
		var speed = dnst.toString();
	    var codelen = speed.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = speed.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++;
		/*densityCmd[2] = parseInt(dnst);
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = densityCmd[i];
			this.indexPos++;
		}*/
	},
	ParseOrientation : function(ori){
		var orientationCmd = [0x53, 0x4F, 0x00, 0x0d],i;
		if(ori == "TOP_TO_BOTTOM" ) orientationCmd[2] = 84;
		else orientationCmd[2] = 66;		
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = orientationCmd[i];
			this.indexPos++;
		}
	},
	ParseCutter : function(en,pd){
		var cutCmd = [0x43,0x55, 0x54,0x79,0X2c,0x00,0x0d],i;
		en = parseInt(en);		
		if(en == 0 ) 
		{
			cutCmd[3]=0x6E;//'n';
			//cutCmd[5]= parseInt(pd);;
		}
		else
		{
			cutCmd[3]=0x79;//'y'
			//cutCmd[5]= parseInt(pd);;
		}
			
		for(i=0;i<5;i++)
		{
			this.PrintData[this.indexPos] = cutCmd[i];
			this.indexPos++;
		}

		var s = pd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++;
	},
	ParseOffSet : function(oset){
		//var offsetCmd = [],i,l=0;
		this.PrintData[this.indexPos++] =0x53;//S
	    this.PrintData[this.indexPos++] =0x41;//A
	    var i;
		var s = oset.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++;
		/*oset =  parseInt(oset);
		if(oset<0)
		{
			offsetCmd[0]=0x53;//'S';
			offsetCmd[1]=0x41;//'A';
			offsetCmd[2]=oset;offsetCmd[3]=0x0d;
			l=4;
		}
		else
		{
			offsetCmd[0]=0x53;//'S';
			offsetCmd[1]=0x41;//'A';
			offsetCmd[3]='-'
			offsetCmd[4]=oset;offsetCmd[5]=0x0d;
			l=5;	
		}			
		for(i=0;i<l;i++)
		{
			this.PrintData[this.indexPos] = offsetCmd[i];
			this.indexPos++;
		}*/
	},
	ParseCutPosition : function(p){
		var positionCmd = [],i,l=0;
		p =  parseInt(p);
		if(0<=p)
		{
			this.PrintData[this.indexPos++]=0x54;//'T';
			this.PrintData[this.indexPos++]=0x41;//'A';			
		}
		else
		{
			this.PrintData[this.indexPos++]=0x54;//'T';
			this.PrintData[this.indexPos++]=0x41;//'A';
			this.PrintData[this.indexPos++]=0x2D;//'-'
			//positionCmd[3]=p;
			//positionCmd[4]=0x0d;
			//l=5;	
		}	
	    var i;
		var s = p.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++		
		/*for(i=0;i<l;i++)
		{
			this.PrintData[this.indexPos] = positionCmd[i];
			this.indexPos++;
		}*/
	},
	ParsePrintingType : function(ty){
		var printingCmd = [0x53,0x54,0x00,0x0d],i;
		if(ty == "DIRECT")printingCmd[2]=0x64;//'d';
		else printingCmd[2]=0x74;//'t';
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = printingCmd[i];
			this.indexPos++;
		}
	},
	ParseBackFeed : function(bkfd,st){
		/*var backFeedCmd = [0x53,0x46,0x00,0x0d],i;			
		backFeedCmd[2]=parseInt(bkfd);			
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = backFeedCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++] = 0x53;//S
		this.PrintData[this.indexPos++] = 0x46;//F
		var i;
		var s = bkfd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    var s1 = st.toString();
	    var codelen = s1.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s1.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x0D;        
	    this.indexPos++;
	},
	ParseSetPaper : function(w,h,mtype,oset,gl){
		//var setPaperCmd = [0x53,0x4C,0x00,0x00,0x00,0x00,0x0d,0x53,0x57,0x00,0x0d],i,ty;			
		if(mtype == "GAP")ty = 0x47;//'G'; 
		else if (mtype == "CONTINUOUS")ty = 0x43;//'C';	
		else if (mtype == "BLACK_MARK")ty = 0x42;//'B';
		this.PrintData[this.indexPos++] = 0x53;//S
		this.PrintData[this.indexPos++] = 0x4C;//L
		var i;
		var s = h.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;

	    var s = gl.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C; 
	    this.PrintData[this.indexPos++]  = ty;  
	     this.PrintData[this.indexPos++]  = 0x2C;      
	   
	    var s = oset.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x0D; 
	    this.PrintData[this.indexPos++] = 0x53;//S
		this.PrintData[this.indexPos++] = 0x57;//W
		var s = w.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++	

		/*
		setPaperCmd[2]= parseInt(h);
		setPaperCmd[3]= parseInt(gl);
		setPaperCmd[4]= parseInt(ty);
		setPaperCmd[5]= parseInt(oset);
		setPaperCmd[9]= parseInt(w);
		for(i=0;i<11;i++)
		{
			this.PrintData[this.indexPos] = setPaperCmd[i];
			this.indexPos++;
		}*/
		
	},
	ParseSetMargin : function(h,v){
		/*var marginCmd = [0x53,0x4D, 0x00,0x00,0x0d],i;		
		marginCmd[2]= parseInt(h);
		marginCmd[3]= parseInt(v);
		for(i=0;i<5;i++)
		{
			this.PrintData[this.indexPos] = marginCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++] = 0x53;//S
		this.PrintData[this.indexPos++] = 0x4D;//M
		var i;
		var s = h.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = v.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x0D;        
	    this.indexPos++;
	},
	ParseCharacterSet : function(ics,tcode){
		var characterSetCmd = [0x43,0x53, 0x00,0x00,0x0d],i;
		var c,p;
		
		if(ics == "usa")
		{
			c = 0; 
			
		}
		else if(ics == "france")
		{
			c = 1; 
			
		}
		else if(ics == "germany") 
		{
			c = 2; 
			
		}
		else if(ics == "uk")
		{
			c = 3; 
			
		}
		else if(ics == "denmarkI")
		{
			c= 4; 
			
		}
		else if(ics == "sweden")
		{
			c = 5; 
			
		}
		else if(ics == "italy")
		{
			c = 6; 
			
		}
		else if(ics == "spainI")
		{
			
			c=7;
		}
		else if(ics == "norway")
		{
			 
			c=8;
		}
		else if(ics == "denmarkII")
		{
			
			c=9;
		}
		else if(ics == "japan")
		{
			
			c=10;
		}
		
		else if(ics == "spainII")
		{
			
			c=11;
		}
		else if(ics == "latinamerica") 
		{
			
			c=12;
		}
		else if(ics == "korea")
		{
			
			c=13;
		}
		else if(ics == "slovenia")
		{
			
			c=14;
		}
		else if(ics == "china")
		{
			
			c=15;
		}
				
		if(tcode == "CP437") 
		{
			p=0;
		}
		else if(tcode =="CP850")
		{
			p=1;
		}
		else if(tcode =="CP852")
		{
			p=2;
		}
		else if(tcode =="CP860")
		{
			p=3;
		}
		else if(tcode =="CP863")
		{
			p=4;
		}
		else if(tcode =="CP865")
		{
			p=5;
		}
		else if(tcode =="WCP1252")
		{
			p=6;
		}
		else if(tcode =="CP865_WCP1252")
		{
			p=7;
		}
		else if(tcode =="CP857") 
		{
			p=8;
		}
		else if(tcode =="CP737")
		{
			p=9;
		}
		else if(tcode =="WCP1250")
		{
			p=10;
		}
		else if(tcode =="WCP1253")
		{
			p=11; 
		}
		else if(tcode =="WCP1254")
		{
			p=12;
		}
		else if(tcode =="CP855")
		{
			p=13;
		}
		else if(tcode =="CP862")
		{
			p=14;
		}
		else if(tcode =="CP866")
		{
			p=15;
		}
		else if(tcode =="WCP1251")
		{
			p=16;
		}
		else if(tcode =="WCP1255")
		{
			p=17;
		}
		else if(tcode =="CP928")
		{
			p=18;
		}
		else if(tcode =="CP864")
		{
			p=19;
		}
		else if(tcode =="CP755")
		{
			p=20;
		}
		else if(tcode =="WCP1257")
		{
			p=21;
		}
		else if(tcode =="CP858")
		{
			p=22;
		}
		/*
		characterSetCmd[2]= parseInt(c);
		characterSetCmd[3]= parseInt(p);
		for(i=0;i<5;i++)
		{
			this.PrintData[this.indexPos] = characterSetCmd[i];
			this.indexPos++;
		}	*/
		this.PrintData[this.indexPos++] = 0x43;//C				
		this.PrintData[this.indexPos++] = 0x53;//S
		var s = c.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = p.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x0D;
	},
	ParseDeviceFont : function(tx,ty,tfont,tmx,tmy,trsp,trot,trev,tbold,talign,txtData){
		var c,r,rot,bold,rev,align,printCmd=[],i;
		var r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;

		if(tbold == 0)bold=0x4E;//'N';
		else bold=0x66;//'B';
		
		if(trev == 0)rev=0x4E;//'N';
		else rev=0x52;//'R';

		if (talign =="left")align =0x46;//'F'
		else if (talign =="right")align =0x4C;//'L'
		else if (talign =="righttoleft")align =0x52;//'R'

		if(tfont == "DEVICE_ENG_9X15")
		{
			c = 0x30; 
			
		}
		else if(tfont == "DEVICE_ENG_12X20")
		{
			c = 0x31; 
			
		}
		else if(tfont == "DEVICE_ENG_16X25") 
		{
			c = 0x32; 
			
		}
		else if(tfont == "DEVICE_ENG_19X30")
		{
			c = 0x33; 
			
		}
		else if(tfont == "DEVICE_ENG_24X38")
		{
			c= 0x34; 
			
		}
		else if(tfont == "DEVICE_ENG_32X50")
		{
			c = 0x35; 
			
		}
		else if(tfont == "DEVICE_ENG_48X76")
		{
			c = 0x36; 
			
		}
		else if(tfont == "DEVICE_ENG_22X34")
		{
			
			c= 0x37;
		}
		else if(tfont == "DEVICE_ENG_28X44")
		{
			 
			c= 0x38;
		}
		else if(tfont == "DEVICE_ENG_37X58")
		{
			
			c= 0x39;
		}
		else if(tfont == "DEVICE_KOR_16X16")
		{
			
			c=0x61;
		}
		
		else if(tfont == "DEVICE_KOR_24X24")
		{
			
			c=0x62;
		}
		else if(tfont == "DEVICE_KOR_20X20") 
		{
			
			c=0x63;
		}
		else if(tfont == "DEVICE_KOR_26X26")
		{
			
			c=0x64;
		}
		else if(tfont == "DEVICE_KOR_20X26")
		{
			
			c=0x65;
		}
		else if(tfont == "DEVICE_KOR_38X38")
		{
			
			c=0x66;
		}
		else if(tfont == "DEVICE_CHN_GB2312")
		{
			
			c=0x6d;
		}
		else if(tfont == "DEVICE_CHN_BIG5")
		{
			
			c=0x6e;
		}
		else if(tfont == "DEVICE_SHIFT_JIS")
		{
			
			c=0x6a;
		}
		/*
		printCmd[0] = 0x54;//'T'
		printCmd[1] = tx;printCmd[2] = ty;printCmd[2] = c;
		printCmd[3] = tmx;printCmd[4] = tmy;printCmd[5] = parseInt(trsp);
		printCmd[6] = rot;printCmd[7] = rev;printCmd[8] = bold; printCmd[9] =align;
		printCmd[10] = 0x27;
		for(i=0;i<11;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++] = 0x54;//T				
		var s = tx.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = ty.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(c);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(tmx)+0x30;
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(tmy)+0x30;
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = trsp.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(rot);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(rev);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(bold);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(align);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		
	   	var codelen = txtData.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] = txtData[i];// txtData.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseVectorFont : function(tx,ty,tfont,twd,tht,trsp,tbold,trev,trot,tstyle,talign,tdir,txtData){
		var c,r,rot,bold,rev,styl,align,dr, printCmd=[],i;
		var r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(tbold == 0)bold=0x4E;//'N';
		else bold=0x42;//'B';

		if(trev == 0)rev=0x4E;//'N';
		else rev=0x52;//'R';
		
		if(tstyle == 0)styl=0x4E;//'N';
		else styl=0x49;//'I';
		
		if (talign =="left")align =0x4C;//'L'
		else if (talign =="right")align =0x52;//'R'
		else if (talign =="center")align =0x43;//'C'
		
		if (tdir =="lefttoright")dr =0x30;
		else if (tdir =="righttoleft")dr =0x31;
		
		if(tfont == "VECTOR_ASCII")
		{
			c = 0x55; 
			
		}
		else if(tfont == "VECTOR_KS5601")
		{
			c = 0x4B; 
			
		}
		else if(tfont == "VECTOR_BIG5") 
		{
			c = 0x42; 
			
		}
		else if(tfont == "VECTOR_GB2312")
		{
			c = 0x47; 
			
		}
		else if(tfont == "VECTOR_JIS")
		{
			c= 0x4A; 
			
		}
		else if(tfont == "VECTOR_OCRA")
		{
			c = 0x61; 
			
		}
		else if(tfont == "VECTOR_OCRB")
		{
			c = 0x62; 
			
		}
		/*
		printCmd[0] = 0x56;//'V'
		printCmd[1] = tx;printCmd[2] = ty;printCmd[2] = c;
		printCmd[3] = twd;printCmd[4] = tht;printCmd[5] = parseInt(trsp);
		printCmd[6] = bold;printCmd[7] = rev;printCmd[8] = styl; printCmd[9]=rot;
		printCmd[10] =align;printCmd[11] =dr;printCmd[12] =0x27;
		for(i=0;i<13;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++] = 0x56;//T				
		var s = tx.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = ty.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(c);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = twd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	    var s = tht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;
	     var s = trsp.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;	    
	    this.PrintData[this.indexPos++]  = parseInt(bold);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(rev);
   	    this.PrintData[this.indexPos++]  = 0x2C;
   	    this.PrintData[this.indexPos++]  = parseInt(styl);
   	    this.PrintData[this.indexPos++]  = 0x2C;
   	    this.PrintData[this.indexPos++]  = parseInt(rot);
   	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(align);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++]  = parseInt(dr);
	    this.PrintData[this.indexPos++]  = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;

		var codelen = txtData.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  txtData[i];//.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},

	ParseCircle : function(tx,ty,tsize,tm){
		/*var printCmd =[],i;
		printCmd[0] = 0x43;//'C'
		printCmd[1] = 0x44;//'D'
		printCmd[2] = tx;printCmd[3] = ty;
		printCmd[4] = tsize;printCmd[5] = tm;
		for(i=0;i<6;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x43;//C
		this.PrintData[this.indexPos++]=0x44;//D
		var s = tx.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = ty.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	    this.PrintData[this.indexPos++]  = parseInt(tsize)+0x30 ; 
	    this.PrintData[this.indexPos++]  = 0x2C; 
	    this.PrintData[this.indexPos++]  = parseInt(tm)+0x30;        	   
		this.PrintData[this.indexPos] =  0x0d;
		this.indexPos++;
		
	},
	ParseBlock : function(txst,tyst,txend,tyend,topt,thk){
		//var printCmd =[],i,c,l;
		
		if(topt == "BLOCK_OVERWRITE")
		{
			c = 0x4F;//'O' 
			
		}
		else if(topt == "BLOCK_EXCLUSIVEOR")
		{
			c = 0x45; //'E' 
			
		}
		else if(topt == "BLOCK_DELETE") 
		{
			c = 0x44; //'D'
			
		}
		else if(topt == "BLOCK_SLOPE")
		{
			c = 0x53; //'S'
			
		}
		else if(topt == "BLOCK_BOX")
		{
			c= 0x42;//'B' 
			
		}
		
/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x44;//'D'
		printCmd[2] = txst;printCmd[3] = tyst;
		printCmd[4] = txend;printCmd[5] = tyend;printCmd[6] = c;
		if(c == 0x53 || c == 0x42) {printCmd[7] = thk;l=8;}
		else l=7;
		for(i=0;i<l;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x0d;
		this.indexPos++;*/	
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x44;//D
		var s = txst.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = tyst.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = txend.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = tyend.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;

	    this.PrintData[this.indexPos++]  = c;  
	    this.PrintData[this.indexPos++]  = 0x2C; 

	    if(c == 0x53 || c == 0x42) {
	    	var s = thk.toString();
		    var codelen = s.length;
		    for(i=0;i<codelen;i++)
		    {
		        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
		        this.indexPos++;
		    }

	    }
	    this.PrintData[this.indexPos] =  0x0d;
		this.indexPos++;	
		
	},
	Parse1DBarcode : function(tx,ty,type,nbwidth,wbwidth,height,trot,hri1,bzw,data){
		var c,r,rot,bold,rev,styl,align,dr, printCmd=[];
		var r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;

		if(hri1 =="none")hri = 0x30;
		else if(hri1 =="below_1")hri = 0x31;
		else if(hri1 =="above_1")hri = 0x32;
		else if(hri1 =="below_2")hri = 0x33;
		else if(hri1 =="above_2")hri = 0x34;
		else if(hri1 =="below_3")hri = 0x35;
		else if(hri1 =="above_3")hri = 0x36;
		else if(hri1 =="below_4")hri = 0x37;
		else if(hri1 =="above_4")hri = 0x38;

		
//		bar_code_height[2] = height;
//		bar_code_width[2] = width;
		if (type == "CODE39")
		{
			c = 0;   
		}
		else if (type == "CODE128")
		{
			c = 1;   
		}
		else if (type == "I2OF5")
		{
			c = 2;   
		}
		else if (type == "CODABAR")
		{
			c = 3;   
		}
		else if (type == "CODE93")
		{
			c = 4;   
		}
		if(type == "UPC-A")
		{
			c = 5;   
		}
		else if (type == "UPC-E")
		{
			c = 6;   
		}
		else if (type == "EAN13")
		{
			c = 7;   
		}
		else if (type == "EAN8")
		{
			c = 8;   
		}	
		else if (type == "EAN128")
		{
			c = 9;   
		}		
		else if (type == "CODE11")
		{
			c = 10;   
		}
		else if (type == "PLANET")
		{
			c = 11;   
		}
		else if (type == "INDUSTRIAL2OF5") 
		{
			c = 12;  
		}
		else if (type == "STANDARD2OF5") 
		{
			c = 13;  
		}
		else if (type == "LOGMARS")
		{
			c = 14;   
		}			
		else if (type == "EXTENSION")
		{
			c = 15;   
		}
		else if (type == "POSTNET")
		{
			c = 16;   
		}
		
		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x31;
		printCmd[2] = parseInt(tx);printCmd[3] = parseInt(ty);printCmd[4] = c;
		printCmd[5] = parseInt(nbwidth);printCmd[6] = parseInt(wbwidth);printCmd[7] = parseInt(height);
		printCmd[8] = rot;printCmd[9] = parseInt(hri);printCmd[10] = parseInt(bzw); printCmd[11] = 0x27;
		for(i=0;i<12;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x31;//1
		var s = tx.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	   // alert(ty);
	    var s = ty.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = c.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;

	    var s = nbwidth.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;

	    var s = wbwidth.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;

	    var s = height.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = rot;        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = parseInt(hri);        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = bzw.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		var codelen = data.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  data.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;	
	},
	ParseMaxiCode : function(tx,ty,tm,data){
		var printCmd =[],i,c;
		
		if(tm == "MODE0")c=0x30;
		else if(tm == "MODE2")c=0x32;
		else if(tm == "MODE3")c=0x33;
		else if(tm == "MODE4")c=0x34;

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(tx);printCmd[3] = parseInt(ty);
		printCmd[4] = 0x4D;printCmd[5] = c;printCmd[6] = 0x27;
		for(i=0;i<7;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = tx.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ty.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++]= 0x2C; 
		this.PrintData[this.indexPos++]=0x4D;//M
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = parseInt(c);        
	    this.indexPos++;
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		var codelen = data.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  data.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	Parse2DPDF417 : function(col, row,ccount,rcount,lvl,dataComp,hri,spos, wd, ht, trot, pdfdata){
		var printCmd =[],i,c,h,o,r,rot,cmp;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(hri == "none")h=0x30;
		else if(hri == "below")h=0x31;		

		if(spos == "center")o=0x30;
		else if(spos == "upperleft")o=0x31;

		if(dataComp == "COMP_TEXT")cmp=0x30;
		else if(dataComp == "COMP_NUM")cmp=0x31;
		else if(dataComp == "COMP_BINARY")cmp=0x32;

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x50;//'P';
		printCmd[5] = parseInt(ccount);printCmd[6] = parseInt(rcount);
		printCmd[7] = parseInt(lvl);printCmd[8] = cmp;printCmd[9] = h;printCmd[10] = o;
		printCmd[11] = parseInt(wd);printCmd[12] = parseInt(ht);printCmd[13] = rot;
		printCmd[14] = 0x27;
		for(i=0;i<15;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++]= 0x2C; 
		this.PrintData[this.indexPos++]=0x50;//P
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;
	    var s = rcount.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++]= 0x2C;
		var s = ccount.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(lvl)+0x30;
		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(cmp);
		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(h);
		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(o);
		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(wd)+0x30;
		this.PrintData[this.indexPos++]= 0x2C;
		var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++]= parseInt(rot);
		this.PrintData[this.indexPos++]= 0x2C;
		this.PrintData[this.indexPos++] =  0x27;		
		var codelen = pdfdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  pdfdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	Parse2DQRcode : function(col,row,md,lvl,sz,trot,qrdata){
		var printCmd =[],i,m,l,r,rot;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(md == "MOD1")m=0x31;
		else if(md == "MOD2")m=0x32;				

		if(lvl == "ECC7_L")l=0x4C;//'L';
		else if(lvl == "ECC15_M")l=0x4D;//'M';
		else if(lvl == "ECC25_Q")l=0x51;//'Q';
		else if(lvl == "ECC30_H")l=0x48;//'H';

/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x51;//'Q';
		printCmd[5] = m;printCmd[6] = l;
		printCmd[7] = parseInt(sz);printCmd[8] = rot;
		printCmd[9] = 0x27;
		for(i=0;i<10;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x51;//Q
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(m);
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(l);
	    this.PrintData[this.indexPos++] = 0x2C   
	    this.PrintData[this.indexPos++] = parseInt(sz)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C  
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C   
	    this.PrintData[this.indexPos++] = 0x27;
		var codelen = qrdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  qrdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseDataMatrix : function(col,row,sz,rev,trot,matrixdata){
		var printCmd =[],i,rv,r,rot;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(rev == "NORMAL")rv=0x4E;//'N';
		else if(rev == "REVERSE")rv=0x52;//'R';				

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x44;//'D';
		printCmd[5] = parseInt(sz);printCmd[6] = rv;
		printCmd[7] = rot; printCmd[8] = 0x27;
		for(i=0;i<9;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x44;//D
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(sz)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(rv);
	    this.PrintData[this.indexPos++] = 0x2C   	  
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C   
	    this.PrintData[this.indexPos++] = 0x27;
		var codelen = matrixdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  matrixdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseAztec : function(col,row,sz,ext,errval,msymbol,nsymbol,id,trot,aztecdata){
		var printCmd =[],i,ms,ex,r,rot;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(ext == "disable")ex=0x30;
		else if(ext == "enable")ex=0x31;

		if(msymbol == "disable")ms=0x30;
		else if(msymbol == "enable")ms=0x31;				
/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x41;//'A';
		printCmd[5] = parseInt(sz);printCmd[6] = ex;
		printCmd[7] = parseInt(errval); printCmd[8] = ms;printCmd[9] = parseInt(nsymbol);

		for(i=0;i<10;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x41;//A
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(sz)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(ex);
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = errval.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;        	    
	    this.PrintData[this.indexPos++] = parseInt(ms);
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = nsymbol.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++]  = 0x2C;	    
		var codelen = id.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  id.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos++]  = 0x2C;	
		this.PrintData[this.indexPos++] =  parseInt(rot);
		this.PrintData[this.indexPos++]  = 0x2C;
		this.PrintData[this.indexPos++] =  0x27;
		var codelen = aztecdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  aztecdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseCode49 : function(col,row,nwd,wd,ht,hri,md,trot,codedata){
		var printCmd =[],i,ms,ex,r,rot,h;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;

		if(hri == "none")h=0x30;
		else if(hri == "below")h=0x31;
		else if(hri == "above")h=0x32;
/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x46;//'F';
		printCmd[5] = parseInt(nwd);printCmd[6] = parseInt(wd);
		printCmd[7] = parseInt(ht); printCmd[8] = parseInt(hri);printCmd[9] = parseInt(md);
		printCmd[10] = rot; printCmd[11] =   0x27;
		for(i=0;i<12;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x46;//F
	    this.PrintData[this.indexPos++] = 0x2C; 
	    var s = nwd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 	  
		this.PrintData[this.indexPos++] = parseInt(h);//A
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(md)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(rot)
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27; 
		var codelen = codedata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  codedata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseCODABLOCK : function(col,row,nwd,wd,ht,secure,nrows,md,encode,trot,codablockdata){
		var printCmd =[],i,se,mod,rot;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;

		if(md == "CODABLOCK_A") mod = 0x41;//'A';
		else if(md == "CODABLOCK_E") mod = 0x45;//'E';
		else if(md == "CODABLOCK_F") mod = 0x46;//'F';

		if(secure == "disable")se=0x30;
		else if(secure == "enable")se=0x31;

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x43;//'C';
		printCmd[5] = parseInt(nwd);printCmd[6] = parseInt(wd);
		printCmd[7] = parseInt(ht); printCmd[8] = se;printCmd[9] = parseInt(nrows);
		printCmd[10] = mod; printCmd[11] = parseInt(encode);
		printCmd[12] = parseInt(rot);printCmd[13] = 0x27;
		for(i=0;i<14;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x43;//'C';
	    this.PrintData[this.indexPos++] = 0x2C; 
	    var s = nwd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    	  
	    var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = parseInt(se);
	    this.PrintData[this.indexPos++] = 0x2C; 
	    var s = nrows.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(mod);
	    this.PrintData[this.indexPos++] = 0x2C; 
	    var s = encode.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(rot)
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27; 

		var codelen = codablockdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  codablockdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseMicroPDF : function(col,row,wd,ht,md,trot,mpdfdata){
		var printCmd =[],i,r,rot;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x32;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x42;//'B';
		printCmd[5] = parseInt(wd);printCmd[6] = parseInt(ht);
		printCmd[7] = parseInt(md); printCmd[8] = rot;printCmd[9] = 0x27;		
		for(i=0;i<10;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x32;//2

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x42;//'B';
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(wd)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 
	    var s = md.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(rot)
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = mpdfdata.length;
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  mpdfdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;
		this.indexPos++;
	},
	ParseIMB : function(col,row,trot,hri,imbdata){
		var printCmd =[],i,r,rot,h;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;

		if(hri == "none")h=0x30;
		else if(hri == "below")h=0x31;		

/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x33;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x49;//'I';
		printCmd[5] = rot;printCmd[6] = parseInt(hri);
		printCmd[7] = 0x27;
		for(i=0;i<10;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x33;//3

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x49;//'I';
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(h);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = imbdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  imbdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseMSI : function(col,row,nwd,wd,ht,cd,chri,trot,hri,msidata){
		var printCmd =[],i,r,rot,prtcd,h;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if(chri == "disable")prtcd=0x30;
		else if(chri == "enable")prtcd=0x31;



		if(hri == "none")h=0x30;
		else if(hri == "below")h=0x31;
		else if(hri == "above")h=0x32;

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x33;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x4D;//'M';
		printCmd[5] = parseInt(nwd);printCmd[6] = parseInt(wd);
		printCmd[7] = parseInt(ht); printCmd[8] = parseInt(cd);printCmd[9] = prtcd;
		printCmd[10] = parseInt(rot);printCmd[11] = parseInt(hri);
		printCmd[12] = 0x27;
		for(i=0;i<13;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x33;//3

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x4D;//'M';
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = nwd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    	  
	    var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C; 
	    this.PrintData[this.indexPos++] = parseInt(cd)+0x30;
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(prtcd);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(h);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = msidata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  msidata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParsePLESSEY : function(col,row,nwd,wd,ht,chri,trot,hri,plsydata){
		var printCmd =[],i,r,rot,prtcd,h;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		

		if(hri == "none")h=0x30;
		else if(hri == "below")h=0x31;
		else if(hri == "above")h=0x32;

		if(chri == "disable")prtcd=0x30;
		else if(chri == "enable")prtcd=0x31;

		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x33;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x50;//'P';
		printCmd[5] = parseInt(nwd);printCmd[6] = parseInt(wd);
		printCmd[7] = parseInt(ht); printCmd[8] = prtcd;
		printCmd[9] = parseInt(rot);printCmd[10] = parseInt(hri);
		printCmd[11] = 0x27;
		
		for(i=0;i<12;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x33;//3

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x50;//'P';
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = nwd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    	  
	    var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(prtcd);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(h);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = plsydata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  plsydata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseTLC39 : function(col,row,nwd,wd,ht,rht,nwdpdf,trot,tlcdata){
		var printCmd =[],i,r,rot,prtcd;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		/*
		printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x33;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x54;//'T';
		printCmd[5] = parseInt(nwd);printCmd[6] = parseInt(wd);
		printCmd[7] = parseInt(ht); printCmd[8] = parseInt(rht);
		printCmd[9] = parseInt(nwdpdf);printCmd[10] = rot;
		printCmd[11] = 0x27;
		for(i=0;i<12;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/

		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x33;//3

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x54;//'T';
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = nwd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    	  
	    var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = rht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = nwdpdf.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = tlcdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  tlcdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseRSS : function(col,row,type,mag,sep,ht,wd,trot,rssdata){
		var printCmd =[],i,r,rot,c;
		r = parseInt(trot);
		if(r == 0) rot=0x30;
		else if(r == 90)rot=0x31;
		else if(r == 180)rot=0x32;
		else if(r == 270)rot=0x33;
		
		if (type == "RSS")
		{
			c = 0;   
		}
		else if (type == "RSS_TRUNCATED")
		{
			c = 1;   
		}
		else if (type == "RSS_STACKED")
		{
			c = 2;   
		}
		else if (type == "RSS_STACKED_OMNIDIRECTIONAL")
		{
			c = 3;   
		}
		else if (type == "RSS_LIMITED")
		{
			c = 4;   
		}
		if(type == "RSS_EXPANDED")
		{
			c = 5;   
		}
		else if (type == "UPC-A")
		{
			c = 6;   
		}
		else if (type == "UPC-E")
		{
			c = 7;   
		}
		else if (type == "EAN13")
		{
			c = 8;   
		}	
		else if (type == "EAN8")
		{
			c = 9;   
		}		
		else if (type == "EAN128_CC-A")
		{
			c = 10;   
		}
		else if (type == "EAN128_CC-B")
		{
			c = 10;   
		}
		else if (type == "EAN128_CC-C") 
		{
			c = 11;  
		}
		/*printCmd[0] = 0x42;//'B'
		printCmd[1] = 0x33;
		printCmd[2] = parseInt(col);printCmd[3] = parseInt(row);
		printCmd[4] = 0x52;//'R';
		printCmd[5] = parseInt(c);printCmd[6] = parseInt(mag);
		printCmd[7] = parseInt(sep); printCmd[8] = parseInt(ht);
		printCmd[9] = parseInt(wd);printCmd[10] = rot;
		printCmd[11] = 0x27;
		for(i=0;i<12;i++)
		{
			this.PrintData[this.indexPos] =  printCmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++]=0x42;//B
		this.PrintData[this.indexPos++]=0x33;//3

		var s = col.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos]  = 0x2C;        
	    this.indexPos++;	    
	   // alert(ty);
	    var s = row.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }

		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = 0x52;//'R';
	    this.PrintData[this.indexPos++] = 0x2C;
	    var s = c.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
		this.PrintData[this.indexPos++] = 0x2C; 
		var s = mag.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = parseInt(sep)+0x30;
		this.PrintData[this.indexPos++] = 0x2C;
		var s = ht.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
		this.PrintData[this.indexPos++] = 0x2C; 
		var s = wd.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
		this.PrintData[this.indexPos++] = 0x2C; 
		this.PrintData[this.indexPos++] = parseInt(rot);
	    this.PrintData[this.indexPos++] = 0x2C;
	    this.PrintData[this.indexPos++] =  0x27;
		var codelen = rssdata.length;
		//alert("codelen" +codelen +"data="+data);
		for(i=0;i<codelen;i++)
		{
			this.PrintData[this.indexPos] =  rssdata.charCodeAt(i).toString(10);
			this.indexPos++;
		}
		this.PrintData[this.indexPos] =  0x27;
		this.indexPos++;
		this.PrintData[this.indexPos] =  0x0d;;
		this.indexPos++;
	},
	ParseLabelImg : function(ImageWidth,ImageHeight,xPos,yPos,BMPBuff){
		var print_raster 	= [0x1D,0x28,0x4C];
		var print_fn112		= [48,112,48,1,1,49];
		var end_raster		= [29,40,76,2,0,48,50];		
		var LDCmd	= [0x4C,0x44] //'L'.'D'
		var BytesPerLine = parseInt(((((ImageWidth) + 31) & ~31) >> 3));
		var pageSize=0,i=0,tbytes=0;
		
		
		var pageSize =  parseInt(((ImageHeight) * (BytesPerLine)));
		for(i =0 ;i< 2;i++)
		{
			this.PrintData[this.indexPos++] = LDCmd[i];
		}
		this.PrintData[this.indexPos++] = parseInt((xPos % 256));
		this.PrintData[this.indexPos++] = parseInt((xPos / 256));
		this.PrintData[this.indexPos++] = parseInt((yPos % 256));
		this.PrintData[this.indexPos++] = parseInt((yPos / 256));
		this.PrintData[this.indexPos++] = parseInt((BytesPerLine % 256));
		this.PrintData[this.indexPos++] = parseInt((BytesPerLine / 256));
		this.PrintData[this.indexPos++] = parseInt((ImageHeight % 256));
		this.PrintData[this.indexPos++] = parseInt((ImageHeight / 256));
	
		for(i =0 ;i< pageSize;i++)
		{
			this.PrintData[this.indexPos++] = BMPBuff[i];
			
		}
		this.PrintData[this.indexPos] =  0x0d;
		this.indexPos++;
		
		//alert("ParseImg=" +this.PrintData);
				
	},
	PrintStart: function(labelSet, copies){

		/*var prtcmd = [80, 0x31, 1, 0x0D],i;
		prtcmd[1]= parseInt(labelSet);
		prtcmd[2]= parseInt(copies);
		for(i=0;i<4;i++)
		{
			this.PrintData[this.indexPos] = prtcmd[i];
			this.indexPos++;
		}*/
		this.PrintData[this.indexPos++] =0x50;//P	    
	    var i;
		var s = labelSet.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }
	    this.PrintData[this.indexPos] = 0x2C;
	    this.indexPos++;
	    var s = copies.toString();
	    var codelen = s.length;
	    for(i=0;i<codelen;i++)
	    {
	        this.PrintData[this.indexPos]  = s.charCodeAt(i).toString(10);        
	        this.indexPos++;
	    }	
	    this.PrintData[this.indexPos] = 0x0D;
	    this.indexPos++;		
	},

	GetPrintData : function(){
		var hex = this.PrintData;
		this.PrintData= [];
		this.indexPos =0;
		this.PrintData.length =0;
		return hex;		
		},
		
	PrinterInit : function(){
		var print_init = [0x1b,0x40];
		this.PrintData[this.indexPos] = print_init;
		this.indexPos++;		
	},
	
	

};
